*=$7fb0
    byt "C64 CARTRIDGE   " ;header
    byt $00,$00,$00,$40 ;header length
    byt $01,$00 ;version
    byt $00,$08 ;type
    byt $00 ;EXROM
    byt $00 ;GAME
    byt $00,$00,$00,$00,$00,$00
    byt "PSID PLAYER"
*=$7ff0
    byt "CHIP"
    byt $00,$00,$20,$10 ;packet size
    byt $00,$00;chip type
    byt $00,$00;bank number
    byt $80,$00;load address
    byt $20,$00;rom size
*=$8000
	byt <start,>start,$00,$00
	byt $c3,$c2,$cd,$38,$30
*=$9000
start
    ldx #$80
    stx $02
    ldx #$03
	lda load_address+1
	cmp #$04
	bcs sethi
	ldx #$cf
sethi
    stx $03
	ldy #<end
copy
    lda main,y
	sta($02),y
	dey
	bpl copy
	lda song_number
	ldy #<(song+1)
    sta($02),y

    lda initAddress
	ldy #<(init+1)
    sta($02),y
    lda initAddress+1
    iny
    sta($02),y
	jsr set01
	ldy #<(init01+1)
	sta($02),y

    lda playAddress
	ldy #<(play+1)
    sta($02),y
    lda playAddress+1
    iny
    sta($02),y
	ldy #<(type+1)
	sta($02),y
	jsr set01
	ldy #<(play01+1)
	sta($02),y

 	lda #$00
 	sta $d01a
    inc $d019
    lda #$7f
    sta $dc0d
    sta $dd0d
 	lda $dc0d
 	lda $dd0d
 	lda load_address+1
    cmp #$03
	bcc vicras
 	bne initirq
 	lda load_address
 	cmp #$1a
 	bcc vicras
initirq
    ldy $03
 	lda #<irqexit+$80
 	sta $0316
 	sty $0317
 	ldx playAddress+1
 	beq irqvec
    lda #<play01+$80
irqvec
    sta $0314
    sty $0315
    lda #<nmijob+$80
    sta $0318
    sty $0319
vicras
    lda #$1b
    ldx #$00
    sta $d011
    stx $d012
    lda pal_flag
    beq ntsc
pal
    lda #$25
    ldx #$40
    bne timer
ntsc
    lda #$95
    ldx #$42
timer
    sta $dc04
    stx $dc05

    lda #$0f
    sta $d418

    lda irq_mask
    ldx speed
    bne ciainit
vicinit
    sta $d01a
    beq doinit
ciainit
    sta $dc0d
    stx $dc0e
doinit
    lda #$2f
    sta $00
    byt $6c,$02,$00 ;	jmp($0002)
set01
	ldy #$37
	cmp #$a0
	bcc found01
	dey
	cmp #$d0
	bcc found01
	dey
	cmp #$e0
	bcs found01
	dey
found01
	tya
	rts
*=$9100
main
	lda #$0c
	sta $df00
init01
    lda #$37
	sta $01
song
    lda #$00
    tax
    tay
init
    jsr $ffff
type
    lda #$00
    beq run
	lda #$36
	sta $01
run
    cli
idle
    beq idle
    bne idle
play01
	lda #$37
	sta $01
play
	jsr $ffff
	lda #$36
	sta $01
noplay
	inc $d019
	lda $dc0d
irqexit
    pla
	tay
	pla
	tax
	pla
	rti
nmijob
    bit $dd0d
	rti
end
*=$9ff0
song_number byt $00
initAddress byt $00,$00
playAddress byt $00,$00
speed   byt $00
irq_mask byt $00
pal_flag byt $00
load_address byt $00,$00
*=$9fff
byt $00